// ICsFile.h

#pragma once

#ifndef _I_CS_FILE_H_
#define _I_CS_FILE_H_

class CsFile;
struct CsCompilationUnit;
struct CsToken;
template < typename T > class MediumFastDeque;

//------------------------------------------------------------------------------
// ICsFile
//------------------------------------------------------------------------------

class ICsFile
{
public:
	static ICsFile * create();
	//static ICsFile * create ( void * buffer, const char * path );
	static ICsFile * create ( void * buffer, size_t size, bool bAllocated, const char * path );
	virtual ~ICsFile();

// pointer to file in memory (buffer)
// WARNING: last char in file must be '\0' (zero)
	virtual void setBuffer ( void * buffer, size_t size, bool bAllocated ) =0;
	virtual void freeBuffer() =0;
	virtual void * getBuffer() const =0;
	//virtual void setBuffer ( void * buffer ) =0;

// size of file (not used)
	//virtual void setBufferSize ( size_t size ) =0;
	virtual size_t getBufferSize() const =0;

// path to file (used in error reporting)
	virtual void setPath ( const char * path ) =0;
	virtual const char * getPath() const =0;

// get CompilationUnit
	virtual CsCompilationUnit * getCompilationUnit() const =0;

// get tokens
	virtual MediumFastDeque<CsToken> & getTokens() const =0;

// convert internal class to interface class
	static ICsFile * getICsFile ( CsFile * file );
	static CsFile * getCsFile ( ICsFile * file );

protected:
	ICsFile();

private:
	ICsFile ( const ICsFile & rhs );
	ICsFile & operator= ( const ICsFile & rhs );
};

//------------------------------------------------------------------------------

#endif // _I_CS_FILE_H_
