// main.h

#pragma once

#ifndef _MAIN_H_
#define _MAIN_H_

#include <vector>
#include <set>

#include "FileManager.h"

class ICsFile;
class IAssembly;
class PerfomanceStatistics;

//--------------------------------------------------------------

void collect_files ( const char * path, bool recursive, std::vector<ICsFile*> & files );
ICsFile * process_file ( PFile file );
void collect_assemblies ( const char * path, bool recursive, std::vector<IAssembly*> & assemblies );
IAssembly * process_assembly ( PFile file );
void process_project ( std::vector<ICsFile*> & files, std::vector<IAssembly*> & assemblies, std::set<std::string> & macros, PerfomanceStatistics & perfomaceStatistics );

//------------------------------------------------------------------------------
// CommandLineOptions (singleton)
//------------------------------------------------------------------------------

struct CommandLineOptions
{
	std::vector<std::string> include_assemblies_paths;
	std::string input_base_path;
	std::string output_base_path;

	static CommandLineOptions & getInstance();
};

CommandLineOptions & getCommandLineOptions();

//------------------------------------------------------------------------------

#endif // _MAIN_H_
